import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import { Title, HeadProvider, Link, Meta } from 'react-head';
import Body from './Body';
export var SeoProvider = HeadProvider;

var extractKeyFromTag = function extractKeyFromTag(tag) {
  var name = tag.name,
      hreflang = tag.hreflang,
      rel = tag.rel;
  return name || hreflang || rel;
};

var renderTags = function renderTags(_ref) {
  var _ref$tagsArray = _ref.tagsArray,
      tagsArray = _ref$tagsArray === void 0 ? [] : _ref$tagsArray,
      Component = _ref.Component;
  return tagsArray.map(function (tag) {
    var hrefLang = tag.hreflang,
        restOfTagInfo = _objectWithoutProperties(tag, ["hreflang"]);

    return React.createElement(Component, Object.assign({
      key: extractKeyFromTag(tag),
      hrefLang: hrefLang
    }, restOfTagInfo));
  });
};

export default function Seo(_ref2) {
  var bodyAttributes = _ref2.bodyAttributes,
      title = _ref2.title,
      meta = _ref2.meta,
      link = _ref2.link;
  return React.createElement(React.Fragment, null, title && React.createElement(Title, null, title), renderTags({
    tagsArray: meta,
    Component: Meta
  }), renderTags({
    tagsArray: link,
    Component: Link
  }), bodyAttributes && React.createElement(Body, {
    bodyAttributes: bodyAttributes
  }));
}